Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/ZOOMakefile.opts.in
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/ZOOMakefile.opts.in	(revision 512)
@@ -16,4 +16,7 @@
 XML2CFLAGS=@XML2_CPPFLAGS@
 XML2LDFLAGS=@XML2_LDFLAGS@
+
+GLIB_LDFLAGS=@GLIB_LDFLAGS@
+GLIB_CPPFLAGS=@GLIB_CPPFLAGS@
 
 PYTHONCFLAGS=@PYTHON_CPPFLAGS@
Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/configure.ac
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/configure.ac	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/configure.ac	(revision 512)
@@ -190,4 +190,6 @@
 XML2_CPPFLAGS=`$XML2CONFIG --cflags`
 
+
+
 # Check headers file
 CPPFLAGS_SAVE="$CPPFLAGS"
@@ -203,4 +205,14 @@
 AC_SUBST([XML2_CPPFLAGS])
 AC_SUBST([XML2_LDFLAGS])
+
+
+
+GLIB_LDFLAGS=`pkg-config --libs glib-2.0`
+GLIB_CPPFLAGS=`pkg-config --cflags glib-2.0`
+
+AC_SUBST([GLIB_CPPFLAGS])
+AC_SUBST([GLIB_LDFLAGS])
+
+
 
 #============================================================================
Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service.h
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service.h	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service.h	(revision 512)
@@ -82,5 +82,6 @@
 #define IOTYPE_SIZE MAP_SIZE+sizeof(NULL)
 #define MAPS_SIZE (2*sizeof(char*))+sizeof(map*)+MAP_SIZE
-#define SERVICE_SIZE (ELEMENTS_SIZE*2)+(MAP_SIZE*2)+sizeof(char*)
+#define SERVICE_SIZE (ELEMENTS_SIZE*2)+(MAP_SIZE*2)+sizeof(char*)+sizeof(char*)+sizeof(char*)
+//#define SERVICE_SIZE sizeof(struct service)
 
 #define SHMSZ     27
@@ -333,4 +334,6 @@
   typedef struct service{
     char* name;
+    char* identifier;
+    char * zcfg;
     struct map* content;
     struct map* metadata;
@@ -407,5 +410,9 @@
     if(tmp!=NULL){
       if(tmp->name!=NULL)
-	free(tmp->name);
+	        free(tmp->name);
+      if (tmp->identifier!=NULL)
+            free(tmp->identifier);
+      if (tmp->zcfg!=NULL)
+            free(tmp->zcfg);
       freeMap(&tmp->content);
       if(tmp->content!=NULL)
@@ -873,4 +880,8 @@
   static void dumpService(service* s){
     fprintf(stderr,"++++++++++++++++++\nSERVICE [%s]\n++++++++++++++++++\n",s->name);
+    if (s->identifier !=NULL)
+        fprintf(stderr,"IDENTIFIER : %s \n",s->identifier);
+    if (s->zcfg !=NULL)
+        fprintf(stderr,"ZCFG PATH : %s \n",s->zcfg);
     if(s->content!=NULL){
       fprintf(stderr,"CONTENT MAP\n");
Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.h
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.h	(revision 511)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.h	(revision 512)
@@ -26,5 +26,5 @@
 #define ZOO_SERVICE_INTERNAL_H 1
 
-#pragma once 
+#pragma once
 
 #define DEFAULT_SERVICE_URL "http://www.zoo-project.org/"
@@ -38,5 +38,5 @@
 #include <sys/stat.h>
 #include <sys/types.h>
-#include "cgic.h"
+//#include "cgic.h"
 #ifndef WIN32
 #include <sys/ipc.h>
@@ -67,5 +67,5 @@
 #include <openssl/buffer.h>
 
-extern   int conf_read(const char*,maps*);
+extern int conf_read (const char *, maps *);
 
 #ifdef USE_JS
@@ -80,80 +80,85 @@
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 #include <libxml/parser.h>
 #include <libxml/xpath.h>
 
-  static char* SERVICE_URL;
+  static char *SERVICE_URL;
   static xmlNsPtr usedNs[10];
-  static char* nsName[10];
+  static char *nsName[10];
   static xmlDocPtr iDocs[10];
-  static int nbNs=0;
-  static int nbDocs=0;
+  static int nbNs = 0;
+  static int nbDocs = 0;
 
-  int getServiceFromYAML(maps*,char*,service**,char *name);
-  int readServiceFile(maps*, char*,service**,char *);
-  int isValidLang(maps*,const char*);
+  int getServiceFromYAML (maps *, char *, service **, char *name);
+  int readServiceFile (maps *, char *, service **, char *);
+  int isValidLang (maps *, const char *);
 
-  void printHeaders(maps*);
-  void unhandleStatus(maps*);
-  int _updateStatus(maps*);
-  char* getStatus(int);
+  void printHeaders (maps *);
+  void unhandleStatus (maps *);
+  int _updateStatus (maps *);
+  char *getStatus (int);
 
 #ifdef USE_JS
-  char* JSValToChar(JSContext*,jsval*);
-  JSBool JSUpdateStatus(JSContext*,uintN,jsval *);
+  char *JSValToChar (JSContext *, jsval *);
+  JSBool JSUpdateStatus (JSContext *, uintN, jsval *);
 #endif
-  
-  void URLDecode(char *);
-  char *url_encode(char *);
-  char *url_decode(char *);
-  char* getEncoding(maps*);
 
-  int zooXmlSearchForNs(const char*);
-  int zooXmlAddNs(xmlNodePtr,const char*,const char*);
-  void zooXmlCleanupNs();
+  void URLDecode (char *);
+  char *url_encode (char *);
+  char *url_decode (char *);
+  char *getEncoding (maps *);
 
-  int zooXmlAddDoc(xmlNodePtr,const char*,const char*);
-  void zooXmlCleanupDocs();
-  
-  void printExceptionReportResponse(maps*,map*);
-  xmlNodePtr createExceptionReportNode(maps*,map*,int);
-  void printProcessResponse(maps*,map*,int,service*,const char*,int,maps*,maps*);
-  xmlNodePtr printGetCapabilitiesHeader(xmlDocPtr,const char*,maps*);
-  void printGetCapabilitiesForProcess(maps*,xmlNodePtr,service*);
-  xmlNodePtr printDescribeProcessHeader(xmlDocPtr,const char*,maps*);
-  void printDescribeProcessForProcess(maps*,xmlNodePtr,service*);
-  void printFullDescription(int,elements*,const char*,xmlNsPtr,xmlNodePtr);
-  void printDocument(maps*,xmlDocPtr,int);
-  void printDescription(xmlNodePtr,xmlNsPtr,const char*,map*);
-  void printIOType(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,xmlNsPtr,elements*,maps*,const char*);
-  map* parseBoundingBox(const char*);
-  void printBoundingBox(xmlNsPtr,xmlNodePtr,map*);
-  void printBoundingBoxDocument(maps*,maps*,FILE*);
-  void printOutputDefinitions1(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,maps*,const char*);
-  
-  void outputResponse(service*,maps*,maps*,map*,int,maps*,int);
+  int zooXmlSearchForNs (const char *);
+  int zooXmlAddNs (xmlNodePtr, const char *, const char *);
+  void zooXmlCleanupNs ();
 
-  char *base64(const char*,int);
-  char *base64d(const char*,int,int*);
-  void ensureDecodedBase64(maps**);
+  int zooXmlAddDoc (xmlNodePtr, const char *, const char *);
+  void zooXmlCleanupDocs ();
+  void addPrefix (maps * conf, map * level, service * serv);
+  void printExceptionReportResponse (maps *, map *);
+  xmlNodePtr createExceptionReportNode (maps *, map *, int);
+  void printProcessResponse (maps *, map *, int, service *, const char *, int,
+                             maps *, maps *);
+  xmlNodePtr printGetCapabilitiesHeader (xmlDocPtr, const char *, maps *);
+  void printGetCapabilitiesForProcess (maps *, xmlNodePtr, service *);
+  xmlNodePtr printDescribeProcessHeader (xmlDocPtr, const char *, maps *);
+  void printDescribeProcessForProcess (maps *, xmlNodePtr, service *);
+  void printFullDescription (int, elements *, const char *, xmlNsPtr,
+                             xmlNodePtr);
+  void printDocument (maps *, xmlDocPtr, int);
+  void printDescription (xmlNodePtr, xmlNsPtr, const char *, map *);
+  void printIOType (xmlDocPtr, xmlNodePtr, xmlNsPtr, xmlNsPtr, xmlNsPtr,
+                    elements *, maps *, const char *);
+  map *parseBoundingBox (const char *);
+  void printBoundingBox (xmlNsPtr, xmlNodePtr, map *);
+  void printBoundingBoxDocument (maps *, maps *, FILE *);
+  void printOutputDefinitions1 (xmlDocPtr, xmlNodePtr, xmlNsPtr, xmlNsPtr,
+                                elements *, maps *, const char *);
 
-  char* addDefaultValues(maps**,elements*,maps*,int);
+  void outputResponse (service *, maps *, maps *, map *, int, maps *, int);
 
-  int errorException(maps *, const char *, const char *, const char*);
+  char *base64 (const char *, int);
+  char *base64d (const char *, int, int *);
+  void ensureDecodedBase64 (maps **);
 
-  int checkForSoapEnvelope(xmlDocPtr);
+  char *addDefaultValues (maps **, elements *, maps *, int);
 
-  void addToCache(maps*,char*,char*,char*,int);
-  char* isInCache(maps*,char*);
-  int runHttpRequests(maps**,maps**,HINTERNET*);
-  int loadRemoteFile(maps**,map**,HINTERNET*,char*);
+  int errorException (maps *, const char *, const char *, const char *);
 
-  char *readVSIFile(maps*,const char*);
-  void parseIdentifier(maps*,char*,char*,char*);
-  int updateStatus( maps*,const int,const char*);
-  char* getInputValue( maps*,const char*,size_t*);
-  int  setOutputValue( maps*, const char*, char*, size_t);
+  int checkForSoapEnvelope (xmlDocPtr);
+
+  void addToCache (maps *, char *, char *, char *, int);
+  char *isInCache (maps *, char *);
+  int runHttpRequests (maps **, maps **, HINTERNET *);
+  int loadRemoteFile (maps **, map **, HINTERNET *, char *);
+
+  char *readVSIFile (maps *, const char *);
+  void parseIdentifier (maps *, char *, char *, char *);
+  int updateStatus (maps *, const int, const char *);
+  char *getInputValue (maps *, const char *, size_t *);
+  int setOutputValue (maps *, const char *, char *, size_t);
 
 #ifdef __cplusplus
Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_zcfg.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_zcfg.c	(revision 512)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_zcfg.c	(revision 512)
@@ -0,0 +1,206 @@
+#include <string.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <glib.h>
+#include <sys/stat.h>
+#include "service.h"
+#include "service_internal.h"
+#include <libxml/tree.h>
+#include <libxml/xmlmemory.h>
+#include <libxml/parser.h>
+#include <libxml/xpath.h>
+#include <libxml/xpathInternals.h>
+
+
+
+static int SCAN_DEPTH = 7;
+
+
+static GList *serviceCfgList;
+
+static int
+scanServiceCfg (char *rootDir, GList ** serviceList, int level)
+{
+  if (level >= SCAN_DEPTH)
+    return 1;
+  struct dirent *d;
+  DIR *dir = opendir (rootDir);
+  if (dir != NULL)
+    {
+      while ((d = readdir (dir)))
+        {
+          if ((d->d_type == DT_DIR || d->d_type == DT_LNK)
+              && d->d_name[0] != '.' && strstr (d->d_name, ".") == NULL)
+            {
+              char *name =
+                (char *) malloc (strlen (rootDir) + strlen (d->d_name) + 2);
+              name[0] = '\0';
+              strncat (name, rootDir, strlen (rootDir));
+              strncat (name, "/", strlen ("/"));
+              strncat (name, d->d_name, strlen (d->d_name));
+              scanServiceCfg (name, serviceList, level + 1);
+            }
+          else
+            {
+              if (d->d_name[0] != '.')
+                if (strstr (d->d_name, ".zcfg") != NULL)
+                  {
+                    char *name =
+                      (char *) malloc (strlen (rootDir) + strlen (d->d_name) +
+                                       2);
+                    name[0] = '\0';
+                    strncat (name, rootDir, strlen (rootDir));
+                    strncat (name, "/", strlen ("/"));
+                    strncat (name, d->d_name, strlen (d->d_name));
+                    *serviceList = g_list_append (*serviceList, name);
+                  }
+            }
+        }
+    }
+  free (d);
+  closedir (dir);
+  return 1;
+}
+
+static int
+get_identifier (char *root_dir, char *zcfg_path, char **identifier)
+{
+  // On extrait le repertoire racine ainsi que l'extention .zcfg pour contruire l'identifiant
+  // root_dir = /var/www/zoo/cgi-bin/ zcfg_path=/var/www/zoo/cgi-bin/gdal/ndvi/ExtractNDVI.zcfg  ===>  gdal.ndvi.ExtractNDVI
+  char *identifier_tmp =
+    (char *) malloc ((strlen (zcfg_path) + 1) * sizeof (char));
+  identifier_tmp[0] = '\0';
+  int ext_len = strlen (".zcfg");
+  int s_tmp_len = strlen (zcfg_path) - ext_len - strlen (root_dir);
+  if (s_tmp_len > 1)
+    {
+      char *s_tmp = (char *) malloc ((s_tmp_len + 1) * sizeof (char));
+      int j;
+      for (j = 0; j < s_tmp_len; j++)
+        s_tmp[j] = zcfg_path[strlen (root_dir) + j];
+      s_tmp[s_tmp_len] = '\0';
+      char *save_ptr_strtok;
+      char *token = strtok_r (s_tmp, "/", &save_ptr_strtok);
+      strncat (identifier_tmp, token, strlen (token));
+      while (token != NULL)
+        {
+          token = strtok_r (NULL, "/", &save_ptr_strtok);
+          if (token != NULL)
+            {
+              strncat (identifier_tmp, ".", strlen ("."));
+              strncat (identifier_tmp, token, strlen (token));
+            }
+
+        }
+      *identifier =
+        (char *) malloc ((strlen (identifier_tmp) + 1) * sizeof (char));
+      strncpy (*identifier, identifier_tmp, strlen (identifier_tmp) + 1);
+      free (identifier_tmp);
+      free (s_tmp);
+    }
+  return 1;
+}
+
+void
+init_services_conf (char *rootDir)
+{
+  maps *m = (maps *) malloc (MAP_SIZE);
+  GList *L = NULL;
+  scanServiceCfg (rootDir, &L, 0);
+  GList *l = NULL;
+  for (l = L; l; l = l->next)
+    {
+      service *s1 = (service *) malloc (SERVICE_SIZE);
+      get_identifier (rootDir, (char *) (l->data), &(s1->identifier));
+      s1->zcfg = (char *) (l->data);
+      readServiceFile (m, (char *) l->data, &s1, s1->identifier);
+      serviceCfgList = g_list_append (serviceCfgList, s1);
+    }
+}
+
+
+service *
+search_service (char *identifier)
+{
+  GList *l;
+  for (l = serviceCfgList; l; l = l->next)
+    {
+      if (strcasecmp (identifier, ((service *) (l->data))->identifier) == 0)
+        return (service *) l->data;
+    }
+  return NULL;
+}
+
+
+void
+XML_CapabilitiesAllProcess (maps * m, xmlNodePtr nc)
+{
+  GList *l;
+  for (l = serviceCfgList; l; l = l->next)
+    {
+
+      service *serv = (service *) l->data;
+
+      xmlNsPtr ns, ns_ows, ns_xlink;
+      xmlNodePtr n = NULL, nc1, nc2;
+  /**
+   * Initialize or get existing namspaces
+   */
+      int wpsId =
+        zooXmlAddNs (NULL, "http://www.opengis.net/wps/1.0.0", "wps");
+      ns = usedNs[wpsId];
+      int owsId = zooXmlAddNs (NULL, "http://www.opengis.net/ows/1.1", "ows");
+      ns_ows = usedNs[owsId];
+      int xlinkId = zooXmlAddNs (n, "http://www.w3.org/1999/xlink", "xlink");
+      ns_xlink = usedNs[xlinkId];
+
+      map *tmp1;
+      if (serv->content != NULL)
+        {
+          nc1 = xmlNewNode (ns, BAD_CAST "Process");
+          tmp1 = getMap (serv->content, "processVersion");
+          if (tmp1 != NULL)
+            xmlNewNsProp (nc1, ns, BAD_CAST "processVersion",
+                          BAD_CAST tmp1->value);
+          //map *tmp3 = getMapFromMaps (m, "lenv", "level");
+          //addPrefix (m, tmp3, serv);
+          printDescription (nc1, ns_ows, serv->identifier, serv->content);
+          tmp1 = serv->metadata;
+          while (tmp1 != NULL)
+            {
+              nc2 = xmlNewNode (ns_ows, BAD_CAST "Metadata");
+              xmlNewNsProp (nc2, ns_xlink, BAD_CAST tmp1->name,
+                            BAD_CAST tmp1->value);
+              xmlAddChild (nc1, nc2);
+              tmp1 = tmp1->next;
+            }
+          xmlAddChild (nc, nc1);
+        }
+    }
+}
+
+void
+XML_Describe_Process (maps * m, xmlNodePtr nc, char *identifiers)
+{
+  if (strcasecmp ("all", identifiers) == 0)
+    {
+      GList *l;
+      for (l = serviceCfgList; l; l = l->next)
+        {
+          service *serv = (service *) l->data;
+          printDescribeProcessForProcess (m, nc, serv);
+        }
+    }
+  else
+    {
+      char *save_ptr_strtok;
+      char *token = strtok_r (identifiers, ",", &save_ptr_strtok);
+      while (token != NULL)
+        {
+          service *serv = search_service (token);
+          if (serv != NULL)
+            printDescribeProcessForProcess (m, nc, serv);
+          token = strtok_r (NULL, ",", &save_ptr_strtok);
+        }
+    }
+}
Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_zcfg.h
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_zcfg.h	(revision 512)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_zcfg.h	(revision 512)
@@ -0,0 +1,12 @@
+#ifndef SERVICE_ZCFG_H
+#define SERVICE_ZCFG_H 1
+
+
+#include "service.h"
+
+
+void init_services_conf (char *rootDir);
+service *search_service (char *identifier);
+void XML_CapabilitiesAllProcess (maps * m, xmlNodePtr nc);
+void XML_Describe_Process (maps * m, xmlNodePtr nc, char *identifiers);
+#endif
